program Ciel;

uses
  Windows,
  Forms,
  Registry,
  SysUtils,
  Sky_P1 in 'Sky_P1.pas' {Form1},
  Sky_P2 in 'Sky_P2.pas' {Form2},
  Sky_Tstars in 'Sky_Tstars.pas' {Tstars1},
  Sky_Print in 'Sky_Print.pas' {Sky_Print1},
  SkyLib in 'SkyLib.pas',
  Sky_locate in 'Sky_locate.pas' {Sky_Locate1},
  Sky_zoom in 'Sky_zoom.pas' {Zoom1},
  SelCatUnit in 'SelCatUnit.pas' {SelCat},
  printscaleUnit in 'printscaleUnit.pas' {PrintScaleForm},
  RechercheUnit in 'RechercheUnit.pas' {Recherche},
  ShowFile in 'ShowFile.pas' {ShowFileForm},
  splashunit in 'splashunit.pas' {splash},
  HeureUnit in 'HeureUnit.pas' {Heure},
  Observatoire in 'Observatoire.pas' {ObsForm},
  AsteroidesUnit in 'AsteroidesUnit.pas' {AsteroidesForm},
  blinkunit in 'blinkunit.pas' {Blink},
  HorizonUnit in 'HorizonUnit.pas' {Horizon},
  LabelUnit in 'LabelUnit.pas' {LabelForm},
  FontsUnit in 'FontsUnit.pas' {FontsForm},
  LoadAstroImage in 'LoadAstroImage.pas' {LoadAstroForm},
  BigIma in 'BigIma.pas' {BigImaForm},
  LongIdent in 'LongIdent.pas' {LongIdentForm},
  ProjUnit in 'ProjUnit.pas' {ProjForm},
  skyviewunit in 'skyviewunit.pas' {SkyViewForm},
  LangUnit in 'LangUnit.pas' {LangForm},
  ExtUnit in 'ExtUnit.pas' {ExtForm},
  ExitUnit in 'ExitUnit.pas' {ExitForm},
  planning1 in 'planning1.pas' {PlanningForm},
  dssplate in 'dssplate.pas' {DssPlateList},
  helpUnit in 'helpUnit.pas' {helpForm},
  catalog1Unit in 'catalog1Unit.pas',
  Catalog2Unit in 'Catalog2Unit.pas',
  Orbites in 'Orbites.pas',
  Eyepiece in 'Eyepiece.pas' {EyepieceForm},
  Planet1 in 'Planet1.pas',
  Catalogues in 'Catalogues.pas',
  timeskip in 'timeskip.pas' {TimeSkipForm},
  mydialog in 'mydialog.pas' {MsgDialog},
  UserLabel in 'UserLabel.pas' {UserLabelForm};

{$R *.res}
var Registry1: TRegistry;
    buf: shortstring;
    ok : boolean;
    multiinstance : boolean = false;
    f : textfile;
    i : integer;
begin
  Registry1 := TRegistry.Create;       // get install directory
  with Registry1 do begin
    ok:=Openkey('Software\Astro_PC\Ciel',false);
    if ok then begin
      if ValueExists('Install_Dir') then begin
         buf:=ReadString('Install_Dir');
         if (buf<>'BYPASS')and DirectoryExists(buf) then chdir(buf);
      end;
      if ValueExists('Multi_Instance') then multiinstance:=ReadBool('Multi_Instance');
      CloseKey;
    end;
  end;
  Registry1.free;
 if not multiinstance then begin
 {Attempt to create a named mutex}
  CreateMutex(nil, false, 'Cartes_du_Ciel_mutex');
 {if it failed then there is another instance}
  if GetLastError = ERROR_ALREADY_EXISTS then begin
   {Send all windows our custom message - only our other}
   {instance will recognise it, and restore itself}
    if paramcount>0 then begin
       assignfile(f,'@@param@@');
       rewrite(f);
       for i:=1 to paramcount do
          writeln(f,paramstr(i));
       Closefile(f);
       sleep(100);
    end;
    SendMessage(HWND_BROADCAST,
                RegisterWindowMessage('Cartes_du_Ciel_message'),
                paramcount,
                0);
   {Lets quit}
    Halt(0);
  end;
  end;
  Application.Initialize;
 {Tell Delphi to un-hide it's hidden application window}
 {This allows our instance to have a icon on the task bar}
  Application.ShowMainForm := true;
  ShowWindow(Application.Handle, SW_RESTORE);
  if paramstr(1)='-t' then Skylib.DebugOn:=true
                      else Skylib.DebugOn:=false;
  if debugon then initdebug;
  if debugon then MemoryDebug;
  Application.Title := 'Cartes du Ciel';
  if debugon then writedebug('Create Tform1');
  Application.CreateForm(TForm1, Form1);
  Application.CreateForm(TMsgDialog, MsgDialog);
//  Application.CreateForm(TUserLabelForm, UserLabelForm);
  if not application.terminated then begin
  Skylib.Init;
//  if debugon then writedebug('Create TLangForm');
//  Application.CreateForm(TLangForm, LangForm);
  if debugon then writedebug('Create Tsplash');
  splash := Tsplash.create(application);
  splash.show;
  splash.refresh;
  if debugon then MemoryDebug;
//  Application.CreateForm(TForm2, Form2);
  if debugon then writedebug('Create TTstar1');
  Application.CreateForm(TTstars1, Tstars1);
  if debugon then writedebug('Create TSky_Print1');
  Application.CreateForm(TSky_Print1, Sky_Print1);
//  if debugon then writedebug('Create TSky_Locate1');
//  Application.CreateForm(TSky_Locate1, Sky_Locate1);
//  if debugon then writedebug('Create TZoom1');
//  Application.CreateForm(TZoom1, Zoom1);
  if debugon then MemoryDebug;
//  if debugon then writedebug('Create TPrintScaleForm');
//  Application.CreateForm(TPrintScaleForm, PrintScaleForm);
  if debugon then writedebug('Create TRecherche');
  Application.CreateForm(TRecherche, Recherche);
  if debugon then writedebug('Create TShowFileForm');
  Application.CreateForm(TShowFileForm, ShowFileForm);
  if debugon then writedebug('Create THeure');
  Application.CreateForm(THeure, Heure);
//  if debugon then writedebug('Create TObsForm');
//  Application.CreateForm(TObsForm, ObsForm);
  if debugon then writedebug('Init Orbites');
  Orbites.init;
  if debugon then MemoryDebug;
  if debugon then writedebug('Create TSelCat');
  Application.CreateForm(TSelCat, SelCat);
//  if debugon then writedebug('Create TAsteroidesForm');
//  Application.CreateForm(TAsteroidesForm, AsteroidesForm);
//  if debugon then writedebug('Create TBlink');
//  Application.CreateForm(TBlink, Blink);
//  if debugon then writedebug('Create THorizon');
//  Application.CreateForm(THorizon, Horizon);
  if debugon then writedebug('Create TLabelForm');
  Application.CreateForm(TLabelForm, LabelForm);
//  if debugon then writedebug('Create TFontsForm');
//  Application.CreateForm(TFontsForm, FontsForm);
  if debugon then writedebug('Create TLoadAstroForm');
  Application.CreateForm(TLoadAstroForm, LoadAstroForm);
//  if debugon then writedebug('Create TBigImaForm');
//  Application.CreateForm(TBigImaForm, BigImaForm);
  if debugon then writedebug('Create TLongIdentForm');
  Application.CreateForm(TLongIdentForm, LongIdentForm);
//  if debugon then writedebug('Create TProjForm');
//  Application.CreateForm(TProjForm, ProjForm);
//  if debugon then writedebug('Create TPlanningForm');
//  Application.CreateForm(TPlanningForm, PlanningForm);
  if debugon then MemoryDebug;
{  if NetWorkOn then begin
    if debugon then writedebug('Create TSkyViewForm');
    Application.CreateForm(TSkyViewForm, SkyViewForm);
  end;}
  if NetWorkOn then begin
    if debugon then writedebug('Create TExtForm');
    Application.CreateForm(TExtForm, ExtForm);
  end;
  if debugon then writedebug('Create TExitForm');
  Application.CreateForm(TExitForm, ExitForm);
  if debugon then writedebug('Create TDssPlateList');
  Application.CreateForm(TDssPlateList, DssPlateList);
//  if debugon then writedebug('Create TEyepieceForm');
//  Application.CreateForm(TEyepieceForm, EyepieceForm);
//  if debugon then writedebug('Create ThelpForm');
//  Application.CreateForm(ThelpForm, helpForm);
  Application.CreateForm(TTimeSkipForm, TimeSkipForm);
  if debugon then writedebug('Application Run');
  if debugon then MemoryDebug;
  Application.Run;
  if debugon then MemoryDebug;
  end;
end.
