unit HorizonUnit;

interface

uses math,Skylib,Sky_tstars,HeureUnit,SelCatUnit,Sky_print,
  printers,Registry,IniFiles, catalogues,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, Buttons, ExtCtrls, StdCtrls;

Procedure SetLang;

type
  THorizon = class(TForm)
    StatusBar1: TStatusBar;
    HresizeTimer: TTimer;
    Panel1: TPanel;
    SpeedButton1: TSpeedButton;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    SpeedButton2: TSpeedButton;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    procedure FormShow(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure HresizeTimerTimer(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Horizon: THorizon;
  DrawColor : Starcolarray; GrideColor,ConstLcolor: Tcolor;
  Drawpen,SNb,ComNb,DrawSize : integer;
  HMin_ma,StarSize,StarDyn : double;
//  PlanetL : Tplanetlst;
//  CometPL : Tcometlst ;
  Hbitmap : TbitMap;
  Desc, charttitle, chartdesc : string;
  fontname1,fontname6 : string ;
  fontsize1,fontsize6 : integer;
  CurAzNorth,fontbold1,fontbold6 : boolean;

implementation

uses Sky_P1;



var  Direction,origine,ST : double;
  xminh,xmaxh,yminh,ymaxh,xcentreh,ycentreh,Xshifth,YshiftH : Integer;
  WindowRatioh,BxGlbh,ByGlbh,AxGlbh,AyGlbh,largeurh : Double;
  Xwrldminh,Xwrldmaxh,Ywrldminh,Ywrldmaxh: Double;
  onprinter,nopaint : boolean;
  SaveColor : Starcolarray;
  LeftMargin,RightMargin,TopMargin,BottomMargin : Integer;
  appmsg : array [1..5] of string;
  jdH,arcH,decH : double;

{$R *.DFM}

Procedure SetLang;
var section : string;
    inifile : Tmeminifile;
    i : integer;
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
section:='horizon';
with Horizon do
  with inifile do begin
    Caption:=ReadString(section,'title',deftxt);
    Label1.Caption:=ReadString(section,'t_1',deftxt)+' :';
    BitBtn1.Caption:=ReadString('buttons','help',deftxt);
    BitBtn2.Caption:=ReadString('buttons','close',deftxt);
    BitBtn3.Caption:=ReadString(section,'t_1',deftxt);
    BitBtn4.Caption:=ReadString('buttons','print',deftxt);
    for i:=1 to 5 do begin
       appmsg[i]:=ReadString(section,'m_'+trim(inttostr(i)),deftxt);
    end;
  end;
inifile.free;
end;
end;

Procedure InitString;
begin
appmsg[1]:='Position pointe';
appmsg[2]:='Elvation';
appmsg[3]:='Magnitude';
appmsg[4]:='Comete';
appmsg[5]:='Planete';
end;

Procedure ScaleWindowH;
var X1,x2,Y1,Y2 : Integer;
begin
   X1 := XminH+LeftMargin ; X2 := XmaxH-RightMargin;
   Y1 := YminH+TopMargin ; Y2 := YmaxH-BottomMargin;
   WindowRatioH := (X2-X1) / (Y2-Y1) ;
   XcentreH:=round((x2-x1)/2);
   YcentreH:=round((y2-y1)/2);
   XwrldminH := -largeurH/2;
   YwrldminH := -largeurH/WindowRatioH/2;
   XwrldmaxH := largeurH/2;
   YwrldmaxH := largeurH/WindowRatioH/2;
   BxGlbH:= (X2-X1) / (XwrldmaxH-XwrldminH) ;
   ByGlbH:= (Y1-Y2) / (YwrldmaxH-YwrldminH) ;
   AxGlbH:= - XwrldminH * BxGlbH ;
   AyGlbH:=   YwrldminH * ByGlbH ;
end;

Procedure WindowXYH(x,y:Double; var WindowX,WindowY: Integer);
var xx,yy : integer;
BEGIN
    xx := Trunc(AxGlbH+BxGlbH*x);
    yy := Trunc(AyGlbH+ByGlbH*y);
    WindowX:=round(xx)+Xshifth;
    WindowY:=ymaxh-round(yy)+Yshifth;
END ;

Procedure XYWindowH( x,y: Integer; var Xwindow,Ywindow: double);
var xx,yy : integer;
Begin
   xx:=x-Xshifth;
   yy:=y-Yshifth-ymaxh;
   xwindow:= (xx)/BxGlbH ;
   ywindow:= (yy)/ByGlbH;
end ;

PROCEDURE ProjHorizon(h,A,D : double ; VAR X,Y : double );
VAR al,phi : double ;
BEGIN
h:=degtorad(h);
phi:=(A-D);
// AIT .  Greisen, Calabretta 1996
if phi<-180 then phi:=phi+360;
if phi>180 then phi:=phi-360;
phi:=degtorad(phi);
al:=(sqrt(2/(1+cos(h)*cos(phi/2))))/1.54;  // 1.54 pour conserver la meme echelle (1=90)
x:=(2*al*cos(h)*sin(phi/2));
y:=(al*sin(h));
// proj. maison 1985
//den := ( 1.0 + cos(h) * cos(A_D) ) ;
//X := cos(h) * sin(A_D) / den ;
//Y := sin(h)  / den ;
END ;

PROCEDURE InvProjHorizon(X,Y,D : double ; VAR h,A : double );
BEGIN
{h1:=degtorad(h);
A_D:=degtorad(A-D);
den := ( 1.0 + cos(h1) * cos(A_D) ) ;
X := cos(h1) * sin(A_D) / den ;
Y := sin(h1)  / den ;}
a:=90*(x-1)+d;
h:=90*y;
END ;

PROCEDURE DrawLimite(out : Tcanvas) ;
var al,hl,xl,yl,xp,yp : double ;
    xx,yy : integer;
 Procedure drlm ;
  Var    i : integer ;
 begin
   hl := 0.0 ;
   for i := 1 to 18 do begin
        hl := hl + 5.0 ;
        ProjHorizon(hl,al,direction,xl,yl) ;
        yl := origine-yl ;
        WindowXYH(xp,yp,xx,yy);
        out.MoveTo(xx,yy) ;
        WindowXYH(xl,yl,xx,yy);
        out.LineTo(xx,yy) ;
        xp := xl ; yp := yl ;
   end ;
 end ;
begin
   out.Pen.Width := 2*Drawpen;
   out.Pen.Color:=clBlack;
   al := direction - 90.0 ;
   xp := -1 ; yp := origine ;
   drlm ;
   al := direction + 90.0 ;
   xp := 1 ; yp := origine ;
   drlm ;
   windowXYH(-1,origine,xx,yy);
   out.moveto(xx,yy);
   windowXYH(1,origine,xx,yy);
   out.Lineto(xx,yy);
   out.Pen.Width := Drawpen;
   out.Brush.Color:=DrawColor[0];
   if not onprinter then begin
     windowXYH(0,0.9*origine,xx,yy);
     out.FloodFill(Xx,Yy,clBlack,fsBorder);
   end;
end ;

Procedure DrawConstLH(out : Tcanvas);
type tconstl = record ar1,de1,ar2,de2 : smallint; end;
var
  nomfich : string;
  f : file of tconstl;
  r : tconstl;
  HH,A,h,x,y : double;
//  dm,xx1,yy1,xx2,yy2 : Double;
  x1,y1,x2,y2 : Integer;
  car1,car2,cde1,cde2 : double;
begin
//dm:=minvalue([10*largeur,400]);
out.Pen.Color := ConstLcolor;
out.Pen.Width := DrawPen;
out.Pen.Mode := pmCopy;
nomfich:=BSCpath+'\constl.dat';
if not FileExists(nomfich) then
   ShowMessage(commsg[3]+' CONSTL.DAT  ?\'+BSCpath);
if not FileExists(nomfich) then exit;
assignfile(f,nomfich);
TRY
reset(f);
repeat
  read(f,r);
  car1:=r.ar1/1000;
  cde1:=r.de1/100;
  car2:=r.ar2/1000;
  cde2:=r.de2/100;
  precession(jd2000,jdh,car1,cde1);
  precession(jd2000,jdh,car2,cde2);
  HH := ST - car1 ;
  Horizontal(15*HH,cde1,A,h) ;
  ProjHorizon(h,A,direction,X,Y) ;
  if ((rmod(direction-A+720,360) < 90.0) or (rmod(A-direction+720,360)<90.0))and (h>0) then begin
     windowxyH(x,origine-y,X1,Y1) ;
     HH := ST - car2 ;
     Horizontal(15*HH,cde2,A,h) ;
     ProjHorizon(h,A,direction,X,Y) ;
     if ((rmod(direction-A+720,360) < 90.0) or (rmod(A-direction+720,360)<90.0))and (h>0) then begin
        windowxyH(x,origine-y,X2,Y2) ;
        out.MoveTo(x1,y1);
        out.LineTo(x2,y2);
     end;
  end;
until eof(f);
FINALLY
closefile(f);
END;
end;

Procedure DrawStarH(ar,de,ma,b_v : double; out : Tcanvas);
VAR HH,A,h,x,y : double;
    Xx,Yy,Icol,ds,ds2 : integer;
    co : Tcolor;
begin
with out do begin
     HH := ST - ar ;
     Horizontal(15*HH,de,A,h) ;
     ProjHorizon(h,A,direction,X,Y) ;
     if ((rmod(direction-A+720,360) < 90.0) or (rmod(A-direction+720,360)<90.0))
        and (h>0)  then begin
           windowxyH(x,origine-y,Xx,Yy) ;
   Icol:=Round(b_v*10);
   case Icol of
         -999..-3: co := DrawColor[1];
           -2..-1: co := DrawColor[2];
            0..2 : co := DrawColor[3];
            3..5 : co := DrawColor[4];
            6..8 : co := DrawColor[5];
            9..13: co := DrawColor[6];
          14..900: co := DrawColor[7];
          else co:=DrawColor[11];
     end;
     ds := round(maxvalue([3,(starsize*(hmin_ma-ma*stardyn/80)/hmin_ma)])*drawsize);
     ds2:= round(ds/2);
     Brush.Color := co ;
     Pen.Color:=DrawColor[0];
     Pen.Width:=drawpen;
     case ds of
       1..2: Ellipse(xx,yy,xx+ds,yy+ds);
       3: Ellipse(xx-1,yy-1,xx+2,yy+2);
       4: Ellipse(xx-2,yy-2,xx+2,yy+2);
       5: Ellipse(xx-2,yy-2,xx+3,yy+3);
       6: Ellipse(xx-3,yy-3,xx+3,yy+3);
       7: Ellipse(xx-3,yy-3,xx+4,yy+4);
       else Ellipse(xx-ds2,yy-ds2,xx+ds2,yy+ds2);
     end;
     end;
end ;
end;

procedure DrawBSCH(out : Tcanvas) ;
var
   ar,de,mv,b_v : double;
   lin : BSCrec;
   ok : boolean;
begin
OpenBSC(0.1,23.9,89,-89,ok);
if not ok then exit;
repeat
  ReadBSC(lin,ok);
  mv:=lin.mv/100;
  if mv>hMin_ma then begin
     NextBSC(ok);
     continue;
  end;
  ar:=lin.ar/100000/15;
  de:=lin.de/100000;
  precession(jd2000,jdh,ar,de);
  b_v:=lin.b_v/100;
  DrawStarH(ar,de,mv,b_v,out);
until not ok ;
end;

Procedure PlanetSymbolH(ar,de :double; ipla: integer; out : Tcanvas);
var
    HH,A,h,x,y : double;
    xx,yy,bs : integer;
begin
with out do begin
     HH := ST - ar ;
     Horizontal(15*HH,de,A,h) ;
     ProjHorizon(h,A,direction,X,Y) ;
     if ((rmod(direction-A+720,360) < 90.0) or (rmod(A-direction+720,360)<90.0))
        and (h>0)  then begin
           windowxyH(x,origine-y,Xx,Yy) ;
  if onprinter then bs:=30 else bs:=10;
  if ipla=99 then ipla:=12;
  if onprinter then begin
       CopyMode :=cmSrcAnd;
       PrintBitMap(out,Rect(xx-bs,yy-bs,xx+bs,yy+bs),Ibmp[ipla]);
    end
    else if (drawcolor[0]<drawcolor[11]) then begin
            CopyMode :=cmSrcPaint;
            StretchDraw(Rect(xx-bs,yy-bs,xx+bs,yy+bs),Pbmp[ipla]);
         end
         else begin
            CopyMode :=cmSrcAnd;
            StretchDraw(Rect(xx-bs,yy-bs,xx+bs,yy+bs),Ibmp[ipla]);
         end;
  end;
 end;
end;

Procedure DrawPlanetH(out : Tcanvas);
var ipla,j : integer;
    ar,de : double;
begin
for j:=0 to SNb-1 do begin
  for ipla:=1 to 11 do begin
    if ipla=3 then continue;
    ar:=Planetlst[j,ipla,1];
    de:=Planetlst[j,ipla,2];
    precession(jd2000,jdh,ar,de);
    planetsymbolH(ar,de,ipla,out);
  end;
end;
end;

Procedure DrawCometH(out : Tcanvas);
var i,j : integer;
    ar,de : double;
begin
for j:=0 to SNb-1 do begin
  for i:=1 to ComNb do begin
   ar:=CometPlst[j,i,1];
   de:=CometPlst[j,i,2];
   precession(jd2000,jdh,ar,de);
   PlanetSymbolH(ar,de,99,out);
  end;
end;
end;

Procedure SetAzimut;
var HH,A,h : double;
begin
ST:=sidtim(jd(CurYear,CurrentMonth,CurrentDay,0),CurrentTime-TimeBias,ObsLongitude);
HH := ST - arcH ;
Horizontal(15*HH,decH,A,h) ;
direction:=A;
end;

Procedure DrawGride(out : Tcanvas);
var a,h,y,x,aa : double;
    i,j,xx,yy : integer;
    buf:string;
begin
a := (round(direction) div 30)*30-90;
with out do begin
Pen.color:=GrideColor;
Pen.width:=drawpen;
Brush.Style:=bsClear;
Font.Color:=clBlack;
Font.Name:=fontname1;
Font.Size:=fontsize1;
if FontBold1 then font.style:=[fsBold] else font.style:=[];
for i:=1 to 6 do begin
 a:=a+30;
 h:=0;
 ProjHorizon(h,a,direction,x,y) ;
 WindowXYH(x,origine-y,xx,yy);
 if AzNorth then aa:=rmod(A+180,360) else aa:=a;
 str(rmod(aa+360,360):3:0,buf);
 buf:=trim(buf);
 if AzNorth then begin
   if buf='180' then buf:='S';
   if buf='270' then buf:='W';
   if buf='0' then buf:='N';
   if buf='90' then buf:='E';
 end else begin
   if buf='0' then buf:='S';
   if buf='90' then buf:='W';
   if buf='180' then buf:='N';
   if buf='270' then buf:='E';
 end;
 TextOut(round(xx-5*drawsize),round(yy+5*drawsize),buf);
 MoveTo(xx,yy) ;
 for j:=1 to 18 do begin
   h:=h+5;
   ProjHorizon(h,a,direction,x,y) ;
   WindowXYH(x,origine-y,xx,yy);
   LineTo(xx,yy) ;
 end;
end;
h:=0;
for i:=1 to 5 do begin
 h:=h+15;
 a := direction-90;
 ProjHorizon(h,a,direction,x,y) ;
 WindowXYH(x,origine-y,xx,yy);
 str(h:2:0,buf);
 TextOut(round(xx-10*drawsize),round(yy-15*drawsize),buf);
 MoveTo(xx,yy) ;
 for j:=1 to 18 do begin
   a:=a+10;
   ProjHorizon(h,a,direction,x,y) ;
   WindowXYH(x,origine-y,xx,yy);
   LineTo(xx,yy) ;
 end;
end;
end;
end;

Procedure RefreshH;
var DestR,SrcR : Trect;
begin
   DestR.Left:=xminh; DestR.Top:=yminh; DestR.Right:=xmaxh; DestR.Bottom:=ymaxh;
   SrcR.Left:=0; SrcR.Top:=0; SrcR.Right:=xmaxh-xminh; SrcR.Bottom:=ymaxh-yminh;
   Horizon.Canvas.CopyRect(DestR,HBitMap.Canvas,SrcR);
end;

PROCEDURE REDRAW ;
var HH,A,h,x,y,AA : double;
    xx,yy : integer;
begin
try
jdh := jd(CurYear,CurrentMonth,CurrentDay,0);
arcH := arcentre;
decH := decentre;
if projpole<>1 then precession(jd2000,jdh,arcH,decH);
screen.cursor:=crHourGlass;
ST:=sidtim(jd(CurYear,CurrentMonth,CurrentDay,0),CurrentTime-TimeBias,ObsLongitude);
HH := ST - arcH ;
Horizontal(15*HH,decH,A,h) ;
with Horizon do begin
  with ClientRect do begin
    xminh := left; xmaxh := right;
    yminh := top; ymaxh := bottom-Horizon.Statusbar1.Height;
  end;
end;
Xshifth:=0;
Yshifth:=-20;
LeftMargin:=0; RightMargin:=0;
TopMargin:=0; BottomMargin:=0;
With Hbitmap do begin
  Width :=xmaxh-xminh;
  Height:=ymaxh-yminh;
  Canvas.brush.style := bsSolid;
  Canvas.brush.color := clBtnface;
  Canvas.pen.Color := clBtnface;
  Canvas.Rectangle(xminh+LeftMargin,yminh+TopMargin,xmaxh-RightMargin,ymaxh-BottomMargin);
end;
largeurh:= 2;
ScaleWindowH ;
origine:=1/windowratioh;
drawLimite(Hbitmap.canvas) ;
DrawGride(Hbitmap.canvas);
RefreshH;
if ShowConstL then DrawConstlH(Hbitmap.canvas);
DrawBscH(Hbitmap.canvas);
DrawPlanetH(Hbitmap.canvas);
DrawCometH(Hbitmap.canvas);
CurAzNorth:=AzNorth;
if AzNorth then AA:=rmod(A+180,360) else AA:=A;
Horizon.StatusBar1.Panels.items[0].Text:=appmsg[1]+' '+horizon.label1.caption+DEmToStr(AA)+' '+appmsg[2]+' :'+DemToStr(h)+' : AR:'+ArmTostr(arcH)+' DE:'+DemTostr(decH);
if AzNorth then AA:=rmod(direction+180,360) else AA:=direction;
Horizon.Edit1.Text:=inttostr(round(AA));
Hbitmap.Canvas.brush.style := bsClear;
Hbitmap.Canvas.pen.Color := DrawColor[11];
ProjHorizon(h,A,direction,X,Y) ;
if (h>0) then begin
   windowxyH(x,origine-y,Xx,Yy) ;
   Hbitmap.Canvas.Ellipse(xx-8*drawsize,yy-8*drawsize,xx+8*drawsize,yy+8*drawsize);
   Hbitmap.Canvas.MoveTo(xx-10*drawsize,yy); Hbitmap.Canvas.LineTo(xx-6*drawsize,yy);
   Hbitmap.Canvas.MoveTo(xx+9*drawsize,yy); Hbitmap.Canvas.LineTo(xx+5*drawsize,yy);
   Hbitmap.Canvas.MoveTo(xx,yy-10*drawsize); Hbitmap.Canvas.LineTo(xx,yy-6*drawsize);
   Hbitmap.Canvas.MoveTo(xx,yy+9*drawsize); Hbitmap.Canvas.LineTo(xx,yy+5*drawsize);
end;
RefreshH;
finally
screen.cursor:=crDefault;
end;
end;

PROCEDURE PrintH ;
var HH,A,h,x,y,ma,AA : double;
    tl,xx,yy,i,dx,ds,ds2 : integer;
    titre : string;
const b_vstr : array[1..8,1..4] of char =(' <  ','-0.3','-0.1',' 0.2',' 0.5',' 0.8',' 1.3','>   ');
begin
if trim(chartdesc)>'' then desc:=chartdesc
                      else desc:=Sky_P1.Form1.LPanels1.Caption;
ST:=sidtim(jd(CurYear,CurrentMonth,CurrentDay,0),CurrentTime-TimeBias,ObsLongitude);
HH := ST - arcH ;
Horizontal(15*HH,decH,A,h) ;
LeftMargin:=mm2pi(PrtLeftMargin);
RightMargin:=mm2pi(PrtRightMargin);
TopMargin:=mm2pi(PrtTopMargin);
BottomMargin:=mm2pi(PrtBottomMargin)+PrtBoxH*PrtRes;
Printer.Orientation := PrintOrient;
Printer.BeginDoc;
xminh := Printer.Canvas.ClipRect.left;
xmaxh := Printer.Canvas.ClipRect.right;
yminh := Printer.Canvas.ClipRect.top;
ymaxh := Printer.Canvas.ClipRect.bottom;
Yshifth:=-Bottommargin-100*PrtRes;
Xshifth:=LeftMargin;
Printer.Canvas.Pen.Color := clBlack;
Printer.Canvas.Brush.Color := clWhite;
Printer.Canvas.Brush.style := bsSolid;
Printer.Canvas.Pen.Width := 5;
Printer.Canvas.Rectangle(xminh+LeftMargin,yminh+TopMargin,xmaxh-RightMargin,ymaxh-BottomMargin);
largeurh:= 2;
ScaleWindowH ;
origine:=1/windowratioh;
drawLimite(Printer.canvas) ;
DrawGride(Printer.canvas);
if ShowConstL then DrawConstlH(Printer.canvas);
DrawBscH(Printer.canvas);
DrawPlanetH(Printer.canvas);
DrawCometH(Printer.canvas);
Printer.Canvas.brush.style := bsClear;
Printer.Canvas.pen.Color := clBlack;
ProjHorizon(h,A,direction,X,Y) ;
if (h>0) then begin
   windowxyH(x,origine-y,Xx,Yy) ;
   Printer.Canvas.Ellipse(xx-8*drawsize,yy-8*drawsize,xx+8*drawsize,yy+8*drawsize);
   Printer.Canvas.MoveTo(xx-10*drawsize,yy); Printer.Canvas.LineTo(xx-6*drawsize,yy);
   Printer.Canvas.MoveTo(xx+9*drawsize,yy); Printer.Canvas.LineTo(xx+5*drawsize,yy);
   Printer.Canvas.MoveTo(xx,yy-10*drawsize); Printer.Canvas.LineTo(xx,yy-6*drawsize);
   Printer.Canvas.MoveTo(xx,yy+9*drawsize); Printer.Canvas.LineTo(xx,yy+5*drawsize);
end;
if AzNorth then AA:=rmod(A+180,360) else AA:=A;
titre := ObsNom
     +' '+inttostr(CurYear)+'/'+inttostr(currentmonth)+'/'+inttostr(currentday)
     +' '+ArmToStr(CurrentTime)
     +horizon.Label1.caption+DemToStr(direction)
     + '    '+appmsg[1]+' : AR:'+ArmTostr(arcentre)+' DE:'+DemTostr(decentre)+' '+horizon.label1.caption+DEmToStr(AA)+' '+appmsg[2]+' :'+DemToStr(h);

with Printer do begin
  Canvas.Pen.Color := clWhite;
  Canvas.Brush.Color := clWhite;
  Canvas.Font.Color := clBlack;
  Canvas.Font.Name:=fontname6;
  Canvas.Font.Size:=fontsize6;
  if FontBold6 then Canvas.font.style:=[fsBold] else Canvas.font.style:=[];
  Canvas.Brush.Style := bsSolid;
  Canvas.Pen.Width := 1;
  Canvas.Rectangle(xminh,yminh,xminh+LeftMargin,ymaxh);
  Canvas.Rectangle(xmaxh-RightMargin,yminh,xmaxh,ymaxh);
  Canvas.Rectangle(xminh,yminh,xmaxh,yminh+TopMargin);
  Canvas.Rectangle(xminh,ymaxh-BottomMargin,xmaxh,ymaxh);
  Canvas.Pen.Color := clBlack;
  Canvas.Brush.Color := clWhite;
  Canvas.Pen.Width := 5;
  Canvas.Polyline([Point(xminh+LeftMargin,yminh+TopMargin),
                   Point(xminh+LeftMargin,ymaxh-BottomMargin),
                   Point(xmaxh-RightMargin,ymaxh-BottomMargin),
                   Point(xmaxh-RightMargin,yminh+TopMargin),
                   Point(xminh+LeftMargin,yminh+TopMargin)]);
  Canvas.Rectangle(xminh+LeftMargin,ymaxh-BottomMargin,xmaxh-RightMargin,ymaxh-BottomMargin+PrtBoxH*PrtRes);
  Canvas.TextOut(Xminh+LeftMargin+50*PrtRes,ymaxh-BottomMargin+5*PrtRes,titre);
  Canvas.TextOut(Xminh+LeftMargin+50*PrtRes,ymaxh-BottomMargin+45*PrtRes,trim(Desc));
  Canvas.Font.Size:=2*FontSize6;
  tl:=Canvas.TextHeight(ChartTitle)+10*PrtRes;
  Canvas.TextOut(Xminh+LeftMargin+50*PrtRes,yminh+TopMargin-tl,ChartTitle);
  Canvas.Font.Size:=FontSize6;
  { Etoiles }
  Canvas.Pen.Width := 2;
  Canvas.Pen.Color := clBlack;
  Canvas.moveto(Xminh+Leftmargin,ymaxh-BottomMargin+100*PrtRes);
  Canvas.lineto(Xmaxh-Rightmargin,ymaxh-BottomMargin+100*PrtRes);
  xx := Xminh+LeftMargin+50*PrtRes; dx:=55*PrtRes;
  yy := ymaxh-BottomMargin+135*PrtRes;
  Canvas.TextOut(xx,yy+20*PrtRes,appmsg[3]+' :');
  xx:=xx+200*PrtRes;
  for i := 0 to round(hMin_ma) do begin
  ma := i;
  ds := round(maxvalue([3,(starsize*(hmin_ma-ma*stardyn/80)/hmin_ma)])*drawsize);
  ds2:= trunc(ds/2);
  Canvas.Pen.Color := clBlack;
  Canvas.Brush.Color := DrawColor[11];
  Canvas.Ellipse(xx-ds2,yy-ds2,xx+ds2,yy+ds2);
  Canvas.Pen.Color := clBlack;
  Canvas.Brush.Color := clWhite;
  Canvas.TextOut(xx-10*PrtRes,yy+20*PrtRes,inttostr(i));
  xx:=xx+dx;
  end;
  { cometes }
  xx:=xx+dx+100*PrtRes;
  Canvas.CopyMode :=cmSrcAnd;
  Canvas.StretchDraw(Rect(xx-30*PrtRes,yy-30*PrtRes,xx+30*PrtRes,yy+30*PrtRes),Ibmp[12]);
  Canvas.TextOut(xx-50*PrtRes,yy+20*PrtRes,appmsg[4]);
  { Planetes }
  xx:=xx+dx+100*PrtRes;
  Canvas.StretchDraw(Rect(xx-30*PrtRes,yy-30*PrtRes,xx+30*PrtRes,yy+30*PrtRes),Ibmp[5]);
  Canvas.TextOut(xx-50*PrtRes,yy+20*PrtRes,appmsg[5]);
  { couleurs }
  Canvas.Pen.Width := 2;
  Canvas.Pen.Color := clBlack;
  Canvas.Brush.Color := clWhite;
  Canvas.moveto(Xminh+Leftmargin,ymaxh-BottomMargin+200*PrtRes);
  Canvas.lineto(Xmaxh-Rightmargin,ymaxh-BottomMargin+200*PrtRes);
  xx := Xminh+LeftMargin+50*PrtRes; dx:=80*PrtRes;
  yy := ymaxh-BottomMargin+225*PrtRes;
     xx:=xx+dx;
     Canvas.Pen.Color := clBlack;
     Canvas.TextOut(xx-10*PrtRes,yy+20*PrtRes,'B-V :');
     xx:=xx+dx;
     ds2 := 15*PrtRes;
     for i:=1 to 7 do begin
        xx:=xx+dx;
        Canvas.Brush.Color := DrawColor[i];
        Canvas.Ellipse(xx-ds2,yy-ds2,xx+ds2,yy+ds2);
        Canvas.Brush.Color := clWhite;
        Canvas.TextOut(xx-65*PrtRes,yy+20*PrtRes,b_vstr[i]);
     end;
     xx:=xx+dx;
     Canvas.Pen.Color := clBlack;
     Canvas.Brush.Color := clWhite;
     Canvas.TextOut(xx-50*PrtRes,yy+20*PrtRes,b_vstr[8]);
  end;
Printer.EndDoc;
end;

procedure THorizon.FormShow(Sender: TObject);
begin
jdh := jd(CurYear,CurrentMonth,CurrentDay,0);
arcH := arcentre;
decH := decentre;
if projpole<>1 then precession(jd2000,jdh,arcH,decH);
SetAzimut;
Redraw;
end;

procedure THorizon.FormPaint(Sender: TObject);
var curDir : double;
    curjd  : double;
begin
if nopaint then exit;
curdir:=direction;
curjd:=jdh;
jdh := jd(CurYear,CurrentMonth,CurrentDay,0);
arcH := arcentre;
decH := decentre;
if projpole<>1 then precession(jd2000,jdh,arcH,decH);
SetAzimut;
if (curDir=direction)and(curjd=jdh)and(CurAzNorth=AzNorth) then ReFreshH
                    else redraw;
end;

procedure THorizon.SpeedButton1Click(Sender: TObject);
begin
direction:=rmod(direction-30+360,360);
Redraw;
end;

procedure THorizon.SpeedButton2Click(Sender: TObject);
begin
direction:=rmod(direction+30+360,360);
Redraw;
end;

procedure THorizon.FormResize(Sender: TObject);
begin
nopaint:=true;
HresizeTimer.enabled:=true;
end;

procedure THorizon.HresizeTimerTimer(Sender: TObject);
begin
HresizeTimer.enabled:=false;
Redraw;
noPaint:=false;
end;

procedure THorizon.BitBtn3Click(Sender: TObject);
begin
direction:=strtoint(edit1.text);
if AzNorth then direction:=rmod(direction+180,360);
Redraw;
end;

procedure THorizon.BitBtn2Click(Sender: TObject);
begin
Close;
end;

procedure THorizon.FormDestroy(Sender: TObject);
begin
Hbitmap.free;
end;

procedure THorizon.FormCreate(Sender: TObject);
var Registry1 : TRegistry;
    ok : boolean;
begin
initstring;
setlang;
hMin_ma:=5.5;
Registry1 := TRegistry.Create;
with Registry1 do begin
  ok:=Openkey('Software\Astro_PC\Ciel\Config',false);
  if ok then begin
     if ValueExists('HWinTop') then Horizon.Top := ReadInteger('HWinTop');
     if ValueExists('HWinLeft') then Horizon.Left := ReadInteger('HWinLeft');
     if ValueExists('HWinWidth') then Horizon.Width := ReadInteger('HWinWidth');
     if ValueExists('HWinHeight') then Horizon.Height := ReadInteger('HWinHeight');
     if ValueExists('HMin_ma') then hMin_ma := ReadFloat('HMin_ma');
  end;
end;
Hbitmap:=Tbitmap.create;
end;

procedure THorizon.BitBtn4Click(Sender: TObject);
var SaveGrideColor,SaveConstL:Tcolor;
begin
FormPos(Sky_Print.Sky_Print1,
        Horizon.left+BitBtn4.left-200,
        Horizon.top+BitBtn4.top+48);
if charttitle<>'' then begin
   Sky_Print1.ComboBox1.Clear;
   Sky_Print1.ComboBox1.Items.Add(charttitle);
end else Sky_Print1.ComboBox1.text:='';
if chartdesc<>'' then begin
   Sky_Print1.ComboBox2.Clear;
   Sky_Print1.ComboBox2.Items.Add(chartdesc);
end else Sky_Print1.ComboBox1.text:='';
GetPrinterResolution(PrtName,PrinterResolution);
Sky_Print1.Label8.Caption:=Format('%s  %d DPI', [PrtName,PrinterResolution]);
Sky_Print1.FloatEdit1.value:=PrtLeftMargin;
Sky_Print1.FloatEdit2.value:=PrtRightMargin;
Sky_Print1.FloatEdit3.value:=PrtTopMargin;
Sky_Print1.FloatEdit4.value:=PrtBottomMargin;
Sky_Print.Sky_Print1.ShowModal;
if Sky_Print.Sky_Print1.ModalResult=mrOK then begin
  GetPrinterResolution(PrtName,PrinterResolution);
  charttitle:=Sky_Print1.ComboBox1.text;
  chartdesc:=Sky_Print1.ComboBox2.text;
  PrtLeftMargin:=Sky_Print1.FloatEdit1.value;
  PrtRightMargin:=Sky_Print1.FloatEdit2.value;
  PrtTopMargin:=Sky_Print1.FloatEdit3.value;
  PrtBottomMargin:=Sky_Print1.FloatEdit4.value;
  PrintOrient:=Sky_Print.PrintOrient;
  NoPaint:=true;
  SaveColor:=DrawColor;
  SaveGrideColor:=GrideColor;
  SaveConstl:=ConstLcolor;
  if Sky_Print.PrintColor then begin
     DrawColor[0]:=clBlack;
     DrawColor[11]:=clWhite;
     end
  else begin
     DrawColor := Sky_Tstars.BWPrtColor;
     GrideColor:=clBlack;
     ConstLcolor:=clBlack;
  end;
  PrtRes:=maxintvalue([1,PrinterResolution div 300]);
  Drawpen:=2*PrtRes;
  DrawSize:=3*PrtRes;
  onprinter:=true;
  PrintH;
  Drawpen:=1;
  DrawSize:=1;
  onprinter:=false;
  DrawColor:=SaveColor;
  GrideColor:=SaveGrideColor;
  ConstLcolor:=SaveConstL;
  Application.ProcessMessages;
  NoPaint:=false;
  Redraw;
end;
end;

procedure THorizon.BitBtn1Click(Sender: TObject);
begin
showhelp('doc1.html#azimutal');
end;

procedure THorizon.SpeedButton3Click(Sender: TObject);
var i : double;
begin
i:=hMin_ma;
hMin_ma:=minvalue([7.0,hMin_ma+0.5]);
if i<>hMin_ma then Redraw;
end;

procedure THorizon.SpeedButton4Click(Sender: TObject);
var i : double;
begin
i:=hMin_ma;
hMin_ma:=maxvalue([1.0,hMin_ma-0.5]);
if i<>hMin_ma then Redraw;
end;

end.
