unit Observatoire;

interface

uses SkyLib, Sky_locate,IniFiles, Mydialog,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, EnhEdits, ComCtrls, ExtCtrls;

Procedure SetLang;

type
  TObsForm = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    Latitude: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Longitude: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Altitude: TGroupBox;
    Label7: TLabel;
    Label3: TLabel;
    ComboBox1: TComboBox;
    BitBtn4: TBitBtn;
    ComboBox2: TComboBox;
    ComboBox3: TComboBox;
    Label6: TLabel;
    Label8: TLabel;
    LongEdit1: TLongEdit;
    LongEdit2: TLongEdit;
    LongEdit3: TLongEdit;
    LongEdit4: TLongEdit;
    LongEdit5: TLongEdit;
    LongEdit6: TLongEdit;
    FloatEdit1: TFloatEdit;
    GroupBox1: TGroupBox;
    Label9: TLabel;
    fuseau: TEdit;
    UpDown2: TUpDown;
    GroupBox2: TGroupBox;
    BitBtn5: TBitBtn;
    ComboBox4: TComboBox;
    Panel1: TPanel;
    Label10: TLabel;
    FloatEdit2: TFloatEdit;
    FloatEdit3: TFloatEdit;
    Label11: TLabel;
    procedure FormShow(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure ComboBox1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure ComboBox4Click(Sender: TObject);
    procedure LongEdit1Enter(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  ObsForm: TObsForm;
  ObsLatitude,ObsLongitude,ObsAltitude,timezone, Defaulttimezone : double;
  ObsNom : String;

implementation

{$R *.DFM}
var
   ObsFile,CityFile : TstringList;
   appmsg : array [1..5] of string;

Procedure SetLang;
var section : string;
    inifile : Tmeminifile;
    i : integer;
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
section:='observatory';
with ObsForm do
  with inifile do begin
    Label3.Caption:=ReadString(section,'t_2',deftxt);
    Caption:=Label3.Caption;
    Latitude.Caption:=ReadString(section,'t_3',deftxt);
    Label1.Caption:=ReadString(section,'t_4',deftxt);
    Label2.Caption:=ReadString(section,'t_5',deftxt);
    Label6.Caption:=ReadString(section,'t_6',deftxt);
    Longitude.Caption:=ReadString(section,'t_7',deftxt);
    Label4.Caption:=ReadString(section,'t_4',deftxt);
    Label5.Caption:=ReadString(section,'t_5',deftxt);
    Label8.Caption:=ReadString(section,'t_6',deftxt);
    Altitude.Caption:=ReadString(section,'t_8',deftxt);
    Label7.Caption:=ReadString(section,'t_9',deftxt);
    Combobox2.clear;
    combobox2.Items.Add(ReadString(section,'t_10',deftxt));
    combobox2.Items.Add(ReadString(section,'t_11',deftxt));
    Combobox3.clear;
    combobox3.Items.Add(ReadString(section,'t_12',deftxt));
    combobox3.Items.Add(ReadString(section,'t_13',deftxt));
    BitBtn1.Caption:=ReadString('buttons','ok',deftxt);
    BitBtn2.Caption:=ReadString('buttons','help',deftxt);
    BitBtn3.Caption:=ReadString('buttons','cancel',deftxt);
    BitBtn4.Caption:=ReadString(section,'t_1',deftxt);
    BitBtn5.Caption:=ReadString(section,'t_14',deftxt);
    combobox4.text:=ReadString(section,'t_15',deftxt);
    GroupBox1.Caption:=ReadString(section,'t_16',deftxt);
    GroupBox2.Caption:=ReadString(section,'t_17',deftxt);
    Label10.Caption:=ReadString(section,'t_18',deftxt);
    Label11.Caption:=ReadString(section,'t_19',deftxt);
    Label9.Caption:=ReadString('time','t_3',deftxt);
    for i:=1 to 5 do begin
       appmsg[i]:=ReadString(section,'m_'+trim(inttostr(i)),deftxt);
    end;
  end;
inifile.free;
end;
end;

Procedure InitString;
begin
appmsg[1]:='L''observatoire';
appmsg[2]:='est dj dfinit. Voulez-vous le modifier ?'
end;

procedure TObsForm.FormShow(Sender: TObject);
var buf,d,m,s : string;
    p : integer;
begin
if ObsLatitude>=0 then ComboBox2.Itemindex:=0
                  else ComboBox2.Itemindex:=1;
if ObsLongitude>=0 then ComboBox3.Itemindex:=0
                   else ComboBox3.Itemindex:=1;
fuseau.text:=floattostr(timezone);
defaultTimeZone:=timezone;
buf:=ArToStr2(abs(ObsLatitude),d,m,s);
LongEdit1.Text:=d;
LongEdit2.Text:=m;
LongEdit3.Text:=s;
buf:=DeToStr2(abs(ObsLongitude),d,m,s);
LongEdit4.Text:=d;
LongEdit5.Text:=m;
LongEdit6.Text:=s;
FloatEdit1.value:=ObsAltitude;
ComboBox1.Text:=ObsNom;
end;

procedure TObsForm.BitBtn1Click(Sender: TObject);
begin
ObsLatitude:=abs(Longedit1.value+Longedit2.value/60+Longedit3.value/3600);
if ComboBox2.Itemindex=1 then ObsLatitude:=-1*ObsLatitude;
ObsLongitude:=abs(Longedit4.value+Longedit5.value/60+Longedit6.value/3600);
if ComboBox3.Itemindex=1 then ObsLongitude:=-1*ObsLongitude;
ObsAltitude:=Floatedit1.value;
ObsNom:=ComboBox1.Text;
timezone:=strtofloat(fuseau.text);
end;

procedure TObsForm.BitBtn4Click(Sender: TObject);
var obsname : string;
    n : integer;
begin
obsname:=ComboBox1.Text;
n := ComboBox1.Items.IndexOf(obsname);
if n>=0 then begin
  if mrOK<>MyMessageDlg(appmsg[1]+' '+obsname+' '+appmsg[2],
     mtConfirmation,mbOkCancel,0)
  then Exit
  Else ObsFile.Delete(n);
end
else ComboBox1.Items.Add(obsname);
ObsFile.Add(trim(obsname)+''+trim(LongEdit1.Text)+''+trim(LongEdit2.Text)
    +''+trim(inttostr(ComboBox2.Itemindex))+''+trim(LongEdit4.Text)+''
    +trim(LongEdit5.Text)+''+trim(inttostr(ComboBox3.Itemindex))+''
    +trim(FloatEdit1.Text)+''+trim(LongEdit3.Text)+''+trim(LongEdit6.Text)+''+trim(fuseau.Text));
ObsFile.SavetoFile('OBSERVATOIRES.DAT');
end;

procedure TObsForm.FormCreate(Sender: TObject);
var i,n,p : integer;
    buf,b : string;
begin
InitString;
SetLang;
ObsFile := TStringList.Create;
CityFile := TStringList.Create;
ObsFile.sorted:=true;
ComboBox1.sorted:=true;
if FileExists('OBSERVATOIRES.DAT') then begin
if debugon then writedebug('File exists OBSERVATOIRES.DAT');
ObsFile.LoadFromFile('OBSERVATOIRES.DAT');
n:=ObsFile.Count;
if debugon then writedebug('Observatory numbers : '+inttostr(n));
for i:=1 to n do begin
  buf:=copy(ObsFile.Strings[i-1],1,pos('',ObsFile.Strings[i-1])-1);
  ComboBox1.Items.Add(buf);
end;
end;
if Fileexists('City.csv') then begin
  CityFile.LoadFromFile('City.csv');
  n:=CityFile.Count;
  for i:=1 to n do begin
    p:=pos(';',CityFile.Strings[i-1]);
    buf:=copy(CityFile.Strings[i-1],1,p-1);
    b:=copy(CityFile.Strings[i-1],p+1,9999);
    p:=pos(';',b);
    buf:=buf+' : '+copy(b,1,p-1);
    ComboBox4.Items.Add(buf);
  end;
end;
end;

procedure TObsForm.FormDestroy(Sender: TObject);
begin
ObsFile.Free;
end;

procedure TObsForm.ComboBox1Click(Sender: TObject);
var n : integer;
    buf : string;
begin
n := ComboBox1.ItemIndex;
if n>=0 then begin
buf:=ObsFile.Strings[n];
ComboBox1.Text:=copy(buf,1,pos('',buf)-1);delete(buf,1,pos('',buf));
LongEdit1.Text:=copy(buf,1,pos('',buf)-1);delete(buf,1,pos('',buf));
LongEdit2.Text:=copy(buf,1,pos('',buf)-1);delete(buf,1,pos('',buf));
ComboBox2.Itemindex:=strtoint(copy(buf,1,pos('',buf)-1));delete(buf,1,pos('',buf));
LongEdit4.Text:=copy(buf,1,pos('',buf)-1);delete(buf,1,pos('',buf));
LongEdit5.Text:=copy(buf,1,pos('',buf)-1);delete(buf,1,pos('',buf));
ComboBox3.Itemindex:=strtoint(copy(buf,1,pos('',buf)-1));delete(buf,1,pos('',buf));
if pos('',buf)=0 then begin // ancien format
 FloatEdit1.Text:=buf;
 Longedit3.text:='0';
 Longedit6.text:='0';
end else begin   // avec les secondes
 FloatEdit1.Text:=copy(buf,1,pos('',buf)-1);delete(buf,1,pos('',buf));
 LongEdit3.Text:=copy(buf,1,pos('',buf)-1);delete(buf,1,pos('',buf));
 if pos('',buf)=0 then begin // ancien format
   LongEdit6.Text:=buf;
   fuseau.Text:=floattostr(DefaultTimeZone);
 end else begin // avec zone horaire
   LongEdit6.Text:=copy(buf,1,pos('',buf)-1);delete(buf,1,pos('',buf));
   fuseau.Text:=buf;
 end;
end;
end;
end;

procedure TObsForm.BitBtn2Click(Sender: TObject);
begin
showhelp('doc3.html#observatoire');
end;

procedure TObsForm.BitBtn5Click(Sender: TObject);
var buf,sav,d,m,s : string;
    p : integer;
    lon,lat : double;
begin
if debugon then writedebug('Create TSky_Locate1');
Application.CreateForm(TSky_Locate1, Sky_Locate1);
try
Lat:=abs(Longedit1.value+Longedit2.value/60+Longedit3.value/3600);
if ComboBox2.Itemindex=1 then Lat:=-1*Lat;
Lon:=abs(Longedit4.value+Longedit5.value/60+Longedit6.value/3600);
if ComboBox3.Itemindex=1 then Lon:=-1*Lon;
Sky_Locate.ar:=(lon+180)/15;
Sky_Locate.de:=lat;
FormPos(Sky_Locate.Sky_locate1,
          mouse.cursorpos.x,
          mouse.cursorpos.y);
sav:=Sky_Locate.Sky_locate1.caption;
Sky_Locate.Sky_locate1.caption:='';
Sky_locate1.image3.visible:=true;
Sky_locate1.image1.visible:=false;
Sky_locate1.BitBtn4.visible:=true;
Sky_Locate.Sky_locate1.ShowModal;
if Sky_Locate.Sky_locate1.ModalResult=mrOK then begin
lon:=Sky_Locate.ar*15-180;
lat:=Sky_Locate.de;
if lat>=0 then ComboBox2.Itemindex:=0
          else ComboBox2.Itemindex:=1;
if lon>=0 then ComboBox3.Itemindex:=0
          else ComboBox3.Itemindex:=1;
buf:=ArToStr2(abs(lat),d,m,s);
LongEdit1.Text:=d;
LongEdit2.Text:=m;
LongEdit3.Text:='0';
buf:=DeToStr2(abs(lon),d,m,s);
LongEdit4.Text:=d;
LongEdit5.Text:=m;
LongEdit6.Text:='0';
obsform.activecontrol:=Combobox1;
end;
finally
Sky_locate1.free;
if debugon then writedebug('Free TSky_Locate1');
end;
end;

procedure TObsForm.ComboBox4Click(Sender: TObject);
var n,p : integer;
    buf,b1,b2,b3 : string;
    x : double;
begin
n := ComboBox4.ItemIndex;
if n>=0 then begin
buf:=CityFile.Strings[n];
p:=pos(';',buf);
delete(buf,1,p);
p:=pos(';',buf);
ComboBox1.Text:=copy(buf,1,p-1); delete(buf,1,p);
p:=pos(';',buf);
x:=strtofloat(copy(buf,1,p-1)); delete(buf,1,p);
detostr2(x,b1,b2,b3);
if copy(b1,1,1)='+' then ComboBox3.Itemindex:=1
                    else ComboBox3.Itemindex:=0;
longedit4.text:=copy(b1,2,99);
longedit5.text:=b2;
longedit6.text:=b3;
p:=pos(';',buf);
x:=strtofloat(copy(buf,1,p-1)); delete(buf,1,p);
detostr2(x,b1,b2,b3);
if copy(b1,1,1)='+' then ComboBox2.Itemindex:=0
                    else ComboBox2.Itemindex:=1;
longedit1.text:=copy(b1,2,99);
longedit2.text:=b2;
longedit3.text:=b3;
FloatEdit1.text:='0';
x:=-strtofloat(buf);
fuseau.Text:=floattostr(x);
end;
end;

procedure TObsForm.LongEdit1Enter(Sender: TObject);
begin
with sender as Tlongedit do selectall;
end;

end.
