unit Sky_Print;

interface
                 
uses Skylib,Inifiles,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, Printers, EnhEdits;

Procedure SetLang;

type
  TSky_Print1 = class(TForm)
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    RadioGroup1: TRadioGroup;
    BitBtn3: TBitBtn;
    PrintDialog1: TPrintDialog;
    RadioGroup2: TRadioGroup;
    BitBtn4: TBitBtn;
    GroupBox1: TGroupBox;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    BitBtn5: TBitBtn;
    Label8: TLabel;
    FloatEdit1: TFloatEdit;
    FloatEdit2: TFloatEdit;
    FloatEdit3: TFloatEdit;
    FloatEdit4: TFloatEdit;
    Panel1: TPanel;
    Label3: TLabel;
    Label2: TLabel;
    CheckBox1: TCheckBox;
    ComboBox1: TComboBox;
    ComboBox2: TComboBox;
    BitBtn6: TBitBtn;
    CheckBox2: TCheckBox;
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
    procedure RadioGroup2Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Sky_Print1: TSky_Print1;
  PrintOrient: TPrinterOrientation;
  PrintColor,PrintLandscape,PrintList : Boolean;

implementation

{$R *.DFM}

Procedure SetLang;
var section : string;
    inifile : Tmeminifile;
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
section:='print';
with Sky_print1 do
  with inifile do begin
    Caption:=ReadString(section,'t_1',deftxt);
    RadioGroup1.items[0]:=ReadString(section,'t_3',deftxt);
    RadioGroup1.items[1]:=ReadString(section,'t_4',deftxt);
    RadioGroup2.items[0]:=ReadString(section,'t_5',deftxt);
    RadioGroup2.items[1]:=ReadString(section,'t_6',deftxt);
    label2.Caption:=ReadString(section,'t_7',deftxt);
    label3.Caption:=ReadString(section,'t_8',deftxt);
    GroupBox1.Caption:=ReadString(section,'t_9',deftxt);
    Label4.Caption:=ReadString(section,'t_10',deftxt);
    Label5.Caption:=ReadString(section,'t_11',deftxt);
    Label6.Caption:=ReadString(section,'t_12',deftxt);
    Label7.Caption:=ReadString(section,'t_13',deftxt);
    BitBtn5.Caption:=ReadString(section,'t_14',deftxt);
    CheckBox1.Caption:=ReadString(section,'t_15',deftxt);
    BitBtn6.Caption:=ReadString(section,'t_16',deftxt);
    CheckBox2.Caption:=ReadString(section,'t_17',CheckBox2.Caption);
    BitBtn1.Caption:=ReadString('buttons','print',deftxt);
    BitBtn2.Caption:=ReadString(section,'t_2',deftxt);
    BitBtn3.Caption:=ReadString('buttons','cancel',deftxt);
    BitBtn4.Caption:=ReadString('buttons','help',deftxt);
  end;
inifile.free;
end;
end;

procedure TSky_Print1.BitBtn2Click(Sender: TObject);
var n : string;
    r : integer;
begin
  PrintDialog1.Execute;
  GetPrinterResolution(N,r);
  Sky_Print1.Label8.Caption:=Format('%s  %d DPI', [N,r]);
end;

procedure TSky_Print1.BitBtn3Click(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TSky_Print1.BitBtn1Click(Sender: TObject);
begin
  ModalResult := mrOk;
end;

procedure TSky_Print1.RadioGroup1Click(Sender: TObject);
begin
   case RadioGroup1.itemindex of
     0 : begin PrintOrient := poLandscape;
               PrintList :=false;
               CheckBox2.Enabled:=false;
               PrintLandscape:=true;
         end;
     1 : begin PrintOrient := poPortrait;
               CheckBox2.Enabled:=true;
               PrintLandscape:=false;
         end;
   end;
end;

procedure TSky_Print1.CheckBox2Click(Sender: TObject);
begin
 PrintList :=CheckBox2.Checked;
end;

procedure TSky_Print1.RadioGroup2Click(Sender: TObject);
begin
   case RadioGroup2.itemindex of
     0 : PrintColor := True;
     1 : PrintColor := False;
   end;

end;

procedure TSky_Print1.FormShow(Sender: TObject);
begin
if PrintColor then RadioGroup2.itemindex := 0
              else RadioGroup2.itemindex := 1;
if PrintOrient=poLandscape  then RadioGroup1.itemindex := 0
                            else RadioGroup1.itemindex := 1;
CheckBox2.Checked:=PrintList;
end;

procedure TSky_Print1.FormCreate(Sender: TObject);
begin
SetLang;
end;

procedure TSky_Print1.BitBtn4Click(Sender: TObject);
begin
showhelp('doc1.html#print');
end;

procedure TSky_Print1.BitBtn5Click(Sender: TObject);
begin
FloatEdit1.text:='15';
FloatEdit2.text:='15';
FloatEdit3.text:='10';
FloatEdit4.text:='5';
end;

procedure TSky_Print1.CheckBox1Click(Sender: TObject);
begin
ComboBox2.enabled:=checkbox1.checked;
if ComboBox2.enabled then ComboBox2.color:=clWindow else ComboBox2.color:=clBtnFace;
end;

procedure TSky_Print1.BitBtn6Click(Sender: TObject);
begin
FloatEdit1.text:='0';
FloatEdit2.text:='0';
FloatEdit3.text:='0';
FloatEdit4.text:='0';
end;


end.
