unit mydialog;

interface

uses Skylib, IniFiles,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TMsgDialog = class(TForm)
    BtOK: TButton;
    BtCancel: TButton;
    BtYes: TButton;
    BtNo: TButton;
    Label1: TLabel;
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

  function MyMessageDlg(const Msg: string; DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons; HelpCtx: Longint): Integer;
  procedure SetLang;

var
  MsgDialog: TMsgDialog;

implementation

{$R *.DFM}

function Max(I, J: Integer): Integer;
begin
  if I > J then Result := I else Result := J;
end;

procedure SetLang;
var inifile : Tmeminifile;
begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
with MsgDialog do begin
with inifile do begin
 BtOK.Caption:=ReadString('buttons','ok','OK');
 BtCancel.Caption:=ReadString('buttons','cancel','Cancel');
 BtYes.Caption:=ReadString('exit','t_2','Yes');
 BtNo.Caption:=ReadString('exit','t_3','No');
end;
end;
inifile.free;
end;

function MyMessageDlg(const Msg: string; DlgType: TMsgDlgType;
  Buttons: TMsgDlgButtons; HelpCtx: Longint): Integer;
var
  TextWidth, TextHeight : Integer;
  TextRect: TRect;
begin
with MsgDialog do begin
  Caption := Application.Title;
  Canvas.Font := Font;
  SetRect(TextRect, 0, 0, Screen.Width div 2, 0);
  DrawText(Canvas.Handle, PChar(Msg), Length(Msg)+1, TextRect,
      DT_EXPANDTABS or DT_CALCRECT or DT_WORDBREAK or
      DrawTextBiDiModeFlagsReadingOnly);
  TextWidth := TextRect.Right;
  TextHeight := TextRect.Bottom;
  ClientWidth := Max(TextWidth, 200) + 16;
  ClientHeight := TextHeight + BtOK.Height + 24;
  SetRect(TextRect, 8, 8, 8+TextRect.Right, 8+TextRect.Bottom);
  label1.Caption := Msg;
  label1.BoundsRect := TextRect;
  BtOK.top:=ClientHeight-BtOK.Height-4;
  BtOK.left:=(ClientWidth-2*BtOK.Width-32) div 2;
  BtCancel.top:=BtOK.top;
  BtCancel.Left:=BtOK.left+BtOK.Width+32;
  BtYes.top:=BtOK.top;
  BtYes.left:=BtOK.left;
  BtNo.top:=BtCancel.top;
  BtNo.left:=BtCancel.left;
  if mbOk in Buttons then BtOK.BringToFront;
  if mbCancel in Buttons then BtCancel.BringToFront;
  if mbYes in Buttons then BtYes.BringToFront;
  if mbNo in Buttons then BtNo.BringToFront;
end;
result:=MsgDialog.Showmodal;
end;

procedure TMsgDialog.FormCreate(Sender: TObject);
begin
Setlang;
end;

end.
