unit timeskip;

interface

uses Skylib, IniFiles,
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, ComCtrls, ExtCtrls, AviWriter, Gifimage;

type
  TTimeSkipForm = class(TForm)
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Edit3: TEdit;
    Edit4: TEdit;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    UpDown1: TUpDown;
    UpDown2: TUpDown;
    UpDown3: TUpDown;
    UpDown4: TUpDown;
    TrackBar1: TTrackBar;
    SpeedButton4: TSpeedButton;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    AviWriter1: TAviWriter;
    GroupBox1: TGroupBox;
    Edit5: TEdit;
    SpeedButton5: TSpeedButton;
    CheckBox1: TCheckBox;
    SaveDialog1: TSaveDialog;
    ComboBox1: TComboBox;
    RadioGroup1: TRadioGroup;
    Label5: TLabel;
    Label6: TLabel;
    procedure SpeedButton3Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure FormHide(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure SpeedButton5Click(Sender: TObject);
    procedure RadioGroup1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Procedure SetLang;

var
  TimeSkipForm: TTimeSkipForm;

implementation

Uses Sky_P1;
{$R *.DFM}

Var saveyear,savemonth,saveday,GIFrate : integer;
    savetime,step,jdt : double;
    loopactive : boolean = false;
    VideoOpen  : boolean = false;
    GIF : TGIFImage;

Procedure SetLang;
var section : string;
    inifile : Tmeminifile;
const deftxt = '?';
begin
if language>'0' then begin
inifile:=Tmeminifile.create(AppDir+'\language_'+language+'.ini');
section:='Time';
with TimeSkipForm do
  with inifile do begin
    Label1.Caption:=ReadString(section,'t_11',deftxt);
    Label2.Caption:=ReadString(section,'t_12',deftxt);
    Label3.Caption:=ReadString(section,'t_13',deftxt);
    Label4.Caption:=ReadString(section,'t_4',deftxt);
    Groupbox1.Caption:=ReadString(section,'t_17',deftxt);
    Label5.Caption:=ReadString(section,'t_18',deftxt);
    checkbox1.Caption:=ReadString(section,'t_19',deftxt);
    BitBtn1.Caption:=ReadString('buttons','help',deftxt);
    BitBtn2.Caption:=ReadString('buttons','cancel',deftxt);
  end;
inifile.free;
end;
end;

Procedure OpenAVI;
var i : single;
begin
with TimeSkipForm do begin
i:=strtofloat(combobox1.text);
Aviwriter1.FileName:=edit5.text;
aviwriter1.Height:=Form1.chart.Picture.Bitmap.height;
aviwriter1.width:=Form1.chart.Picture.Bitmap.width;
aviwriter1.stretch:=true;
aviwriter1.frametime:=round(1000 / i);
aviwriter1.PixelFormat:=pf24bit;
aviwriter1.OpenAVI;
VideoOpen:=true;
end;
end;

Procedure CloseAVI;
begin
TimeSkipForm.aviwriter1.CloseAVI;
VideoOpen:=false;
end;

Procedure WriteAVI;
begin
TimeSkipForm.aviwriter1.AddBMPtoAVI(Form1.chart.Picture.Bitmap);
end;

Procedure OpenGIF;
begin
GIFrate:=round(100 / strtofloat(TimeSkipForm.combobox1.text));
GIF := TGIFImage.Create;
VideoOpen:=true;
end;

Procedure CloseGIF;
begin
GIF.OptimizeColorMap;
GIF.SaveToFile(TimeSkipForm.edit5.text);
GIF.Free;
VideoOpen:=false;
end;

Procedure WriteGIF;
var
  Ext : TGIFGraphicControlExtension;
  LoopExt : TGIFAppExtNSLoop;
  i : integer;
begin
    // Add the source image to the animation
    i := GIF.Add(Form1.chart.Picture.Bitmap);
    // Netscape Loop extension must be the first extension in the first frame!
    if (i = 0) then
    begin
      LoopExt := TGIFAppExtNSLoop.Create(GIF.Images[i]);
      LoopExt.Loops := 0; // Number of loops (0 = forever)
      GIF.Images[i].Extensions.Add(LoopExt);
    end;
    // Add Graphic Control Extension
    Ext := TGIFGraphicControlExtension.Create(GIF.Images[i]);
    Ext.Delay := GIFrate; // Animation delay (30 = 300 mS)
    GIF.Images[i].Extensions.Add(Ext);
end;


Procedure OpenVideo;
begin
case TimeSkipForm.RadioGroup1.ItemIndex of
0 : OpenAVI;
1 : OpenGIF;
end;
TimeSkipForm.label6.caption:='Recording...';
TimeSkipForm.refresh;
end;

Procedure CloseVideo;
begin
TimeSkipForm.label6.caption:='Closing Video File...';
TimeSkipForm.refresh;
case TimeSkipForm.RadioGroup1.ItemIndex of
0 : CloseAVI;
1 : CloseGIF;
end;
TimeSkipForm.label6.caption:='';
end;

Procedure WriteVideo;
begin
case TimeSkipForm.RadioGroup1.ItemIndex of
0 : WriteAVI;
1 : WriteGIF;
end;
end;


Procedure Redraw;
begin
  NewTime:=true;
  SkipShow:=true;
  Newposition;
  timeskipform.caption:=inttostr(CurYear)+'-'+inttostr(currentmonth)+'-'+inttostr(currentday)+' '+ArToStr(Currenttime);
  if VideoOpen then WriteVideo;
end;

Procedure ForwardTime;
begin
with TimeskipForm do begin
jdt:=jd(CurYear,currentmonth,currentday,currenttime);
step:=updown1.position+updown2.position/24+updown3.position/1440+updown4.position/86400;
jdt:=jdt+step;
djd(jdt,CurYear,currentmonth,currentday,currenttime);
Redraw;
end;
end;

Procedure BackwardTime;
begin
with TimeskipForm do begin
jdt:=jd(CurYear,currentmonth,currentday,currenttime);
step:=updown1.position+updown2.position/24+updown3.position/1440+updown4.position/86400;
jdt:=jdt-step;
djd(jdt,CurYear,currentmonth,currentday,currenttime);
Redraw;
end;
end;

Procedure ResetTime;
begin
CurYear:=saveyear;
CurrentMonth:=savemonth;
CurrentDay:=saveday;
CurrentTime:=savetime;
Redraw;
end;

procedure TTimeSkipForm.SpeedButton3Click(Sender: TObject);
begin
if not loopactive then begin
if trackbar1.Position<10 then begin
loopactive:=true;
if checkbox1.checked then OpenVideo;
repeat
  ForwardTime;
  sleep(100*trackbar1.Position);
  application.processmessages;
until not loopactive;
if VideoOpen then CloseVideo;
end
else ForwardTime;
end;
SpeedButton3.Down:=loopactive and (not SpeedButton1.Down);
end;

procedure TTimeSkipForm.SpeedButton1Click(Sender: TObject);
begin
if not loopactive then begin
if trackbar1.Position<10 then begin
loopactive:=true;
if checkbox1.checked then OpenVideo;
repeat
  BackwardTime;
  sleep(100*trackbar1.Position);
  application.processmessages;
until not loopactive;
if VideoOpen then CloseVideo;
end
else BackwardTime;
end;
SpeedButton1.Down:=loopactive and (not SpeedButton3.Down);
end;

procedure TTimeSkipForm.SpeedButton2Click(Sender: TObject);
begin
if loopactive then loopactive:=false
else ResetTime;
end;

procedure TTimeSkipForm.FormShow(Sender: TObject);
begin
saveyear:=CurYear;
savemonth:=CurrentMonth;
saveday:=CurrentDay;
savetime:=CurrentTime;
timeskipform.caption:=inttostr(CurYear)+'-'+inttostr(currentmonth)+'-'+inttostr(currentday)+' '+ArToStr(Currenttime);
label6.caption:='';
end;

procedure TTimeSkipForm.SpeedButton4Click(Sender: TObject);
begin
TrackBar1.position:=10;
end;

procedure TTimeSkipForm.TrackBar1Change(Sender: TObject);
begin
if trackbar1.position=10 then loopactive:=false;
end;

procedure TTimeSkipForm.FormHide(Sender: TObject);
begin
loopactive:=false;
followon:=false;
ResetObs;
end;

procedure TTimeSkipForm.BitBtn1Click(Sender: TObject);
begin
showhelp('doc1.html#animation');
end;

procedure TTimeSkipForm.BitBtn2Click(Sender: TObject);
begin
Close;
end;

procedure TTimeSkipForm.FormCreate(Sender: TObject);
begin
setlang;
end;

procedure TTimeSkipForm.SpeedButton5Click(Sender: TObject);
begin
savedialog1.FileName:=edit5.text;
if savedialog1.execute then edit5.text:=savedialog1.filename;
chdir(appdir);
end;

procedure TTimeSkipForm.RadioGroup1Click(Sender: TObject);
begin
case RadioGroup1.ItemIndex of
0 : begin
    Savedialog1.defaultext:='.avi';
    Savedialog1.filterindex:=1;
    edit5.text:=changefileext(edit5.text,Savedialog1.defaultext);
    end;
1 : begin
    Savedialog1.defaultext:='.gif';
    Savedialog1.filterindex:=2;
    edit5.text:=changefileext(edit5.text,Savedialog1.defaultext);
    end;
end;
end;

end.
